# amfh265enc

amfh265enc element encodes raw video stream into compressed H.265 bitstream via AMD AMF API.

## Example launch line

    gst-launch-1.0 videotestsrc num-buffers=100 ! amfh265enc ! h265parse ! mp4mux ! filesink location=encoded.mp4

## Hierarchy

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstVideoEncoder
                        ╰──GstAmfEncoder
                            ╰──amfh265enc

## Implemented interfaces

    GstPreset

## Factory details

Authors: – Seungha Yang

Classification: – `Codec/Encoder/Video/Hardware`

Rank – primary

Plugin – amfcodec

Package – GStreamer Bad Plug-ins

## Pad Templates

### `sink`

    video/x-raw(memory:D3D11Memory):
             format: NV12
              width: [ 128, 4096 ]
             height: [ 128, 4096 ]
    video/x-raw:
             format: NV12
              width: [ 128, 4096 ]
             height: [ 128, 4096 ]

Presence – always

Direction – sink

Object type – GstPad

### `src`

    video/x-h265:
              width: [ 128, 4096 ]
             height: [ 128, 4096 ]
            profile: main
      stream-format: byte-stream
          alignment: au

Presence – always

Direction – src

Object type – GstPad

## Properties

### adapter-luid

    “adapter-luid” gint64

DXGI Adapter LUID (Locally Unique Identifier) of associated GPU

Flags : Read

Default value : 0

### aud

    “aud” gboolean

Use AU (Access Unit) delimiter

Flags : Read / Write

Default value : true

### bitrate

    “bitrate” guint

Target bitrate in kbit/sec (0: USAGE default)

Flags : Read / Write

Default value : 0

### gop-size

    “gop-size” guint

Number of pictures within a GOP

Flags : Read / Write

Default value : 30

### max-bitrate

    “max-bitrate” guint

Maximum bitrate in kbit/sec (0: USAGE default)

Flags : Read / Write

Default value : 0

### max-qp-i

    “max-qp-i” gint

Maximum allowed QP value for I frames (-1: USAGE default)

Flags : Read / Write

Default value : -1

### max-qp-p

    “max-qp-p” gint

Maximum allowed QP value for P frames (-1: USAGE default)

Flags : Read / Write

Default value : -1

### min-qp-i

    “min-qp-i” gint

Minimum allowed QP value for I frames (-1: USAGE default)

Flags : Read / Write

Default value : -1

### min-qp-p

    “min-qp-p” gint

Minimum allowed QP value for P frames (-1: USAGE default)

Flags : Read / Write

Default value : -1

### preset

    “preset” Amf-h265enc-preset *

Preset

Flags : Read / Write

Default value : default (-1)

### qp-i

    “qp-i” guint

Constant QP for I frames

Flags : Read / Write

Default value : 26

### qp-p

    “qp-p” guint

Constant QP for P frames

Flags : Read / Write

Default value : 26

### rate-control

    “rate-control” Amf-h265enc-rate-control *

Rate Control Method

Flags : Read / Write

Default value : default (-1)

### ref-frames

    “ref-frames” guint

Number of reference frames

Flags : Read / Write

Default value : 1

### usage

    “usage” Amf-h265enc-usage *

Target usage

Flags : Read / Write

Default value : transcoding (0)

## Named constants

### Amf-h265enc-preset

Encoding quality presets

#### Members

`default` (-1) – Default, depends on USAGE
`quality` (0) – Quality
`balanced` (5) – Balanced
`speed` (10) – Speed

### Amf-h265enc-rate-control

Rate control methods

#### Members

`default` (-1) – Default, depends on Usage
`cqp` (0) – Constant QP
`lcvbr` (1) – Latency Constrained VBR
`vbr` (2) – Peak Constrained VBR
`cbr` (3) – Constant Bitrate

### Amf-h265enc-usage

Encoder usages

#### Members

`transcoding` (0) – Transcoding
`ultra-low-latency` (1) – Ultra Low Latency
`low-latency` (2) – Low Latency
`webcam` (3) – Webcam

The results of the search are